<?php session_start();  

function getOauthToken() {
    $api_url = 'http://endpoint.dashmanager.com/ns-controller/';
    $ch = curl_init();
    if (!$ch) {
        die("Couldn't initialize a cURL handle");
    }
    curl_setopt($ch, CURLOPT_URL, $api_url."?action=auth&username=".$_SESSION['username']."&password=".$_SESSION['password']);
    curl_setopt($ch, CURLOPT_POST, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, "");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
    $status_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
    $curlresponse = curl_exec($ch);
    $response_array = json_decode($curlresponse, true);
    curl_close($ch);
    /*
	$accesstoken = $response_array['access_token'];
    return $accesstoken;
	*/
	return $response_array;
}

function getDomainDetails($response_array) {
    $api_url = "https://".$response_array["server_api_url"].'/ns-api/';
	$crl = curl_init();
    if (!$crl) {
        die("Couldn't initialize a cURL handle");
    }
    curl_setopt($crl, CURLOPT_URL, $api_url);
    curl_setopt($crl, CURLOPT_HTTPHEADER, array('Authorization: Bearer ' . $response_array["access_token"]));
    curl_setopt($crl, CURLOPT_POST, 1);
    curl_setopt($crl, CURLOPT_POSTFIELDS, "action=read&object=subscriber&login=".$_SESSION['username']);
    curl_setopt($crl, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($crl, CURLOPT_FOLLOWLOCATION, true);
    $curlresponse = curl_exec($crl);
    curl_close($crl);
    $xml = new SimpleXMLElement($curlresponse);
    //echo $xml->subscriber->domain;    
    $domain_array = array();
    $domain_array['domain'] = $xml->subscriber->domain;
    $domain_array['user'] = $xml->subscriber->user;

    return $domain_array;
}

function sipCreation($response_array, $user, $domain, $device) {
    $api_url = "https://".$response_array["server_api_url"].'/ns-api/';
    $crl_dev_red = curl_init();
    if (!$crl_dev_red) {
        die("Couldn't initialize a cURL handle");
    }
    curl_setopt($crl_dev_red, CURLOPT_URL, $api_url);
    curl_setopt($crl_dev_red, CURLOPT_HTTPHEADER, array('Authorization: Bearer ' . $response_array["access_token"]));
    curl_setopt($crl_dev_red, CURLOPT_POST, 1);
    curl_setopt($crl_dev_red, CURLOPT_POSTFIELDS, "object=device&action=read&domain=".$domain."&user=".$user);
    curl_setopt($crl_dev_red, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($crl_dev_red, CURLOPT_FOLLOWLOCATION, true);
    $curlresponseread = curl_exec($crl_dev_red);
    curl_close($crl_dev_red);
    /*echo "<pre>";
    print_r($curlresponseread); */   
    
    $xml = new SimpleXMLElement($curlresponseread);    
    $authentication_key = $xml->device->authentication_key; 
    
    
    //$api_url = $_SESSION['apiTargetURI'];
    $crl_dev_cre = curl_init();
    if (!$crl_dev_cre) {
        die("Couldn't initialize a cURL handle");
    }
    curl_setopt($crl_dev_cre, CURLOPT_URL, $api_url);
    curl_setopt($crl_dev_cre, CURLOPT_HTTPHEADER, array('Authorization: Bearer '.$authentication_key));
    curl_setopt($crl_dev_cre, CURLOPT_POST, 1);
    curl_setopt($crl_dev_cre, CURLOPT_POSTFIELDS, "object=device&action=create&owner_domain=" . $domain . "&owner=" . $user . "&uid=" . $user . "@" . $domain . "&device=" . $device);
    curl_setopt($crl_dev_cre, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($crl_dev_cre, CURLOPT_FOLLOWLOCATION, true);
    $curlresponsecreate = curl_exec($crl_dev_cre);
    $status_code = curl_getinfo($crl_dev_cre, CURLINFO_HTTP_CODE);
    //echo $status_code . "----dev<br/>";
    curl_close($crl_dev_cre);
   // print_r($curlresponsecreate);    
    
}

function clickToCall($response_array, $user, $domain, $destination) {
    $api_url = "https://".$response_array["server_api_url"].'/ns-api/';
    $crl_cl = curl_init();
    if (!$crl_cl) {
        die("Couldn't initialize a cURL handle");
    }
    curl_setopt($crl_cl, CURLOPT_URL, $api_url);
    curl_setopt($crl_cl, CURLOPT_HTTPHEADER, array('Authorization: Bearer ' . $response_array["access_token"]));
    curl_setopt($crl_cl, CURLOPT_POST, 1);
    curl_setopt($crl_cl, CURLOPT_POSTFIELDS, "action=call&object=call&callid=123456789&uid=" . $user . "@" . $domain . "&destination=". $user . "@" . $domain . "&origination=" . $destination);
    curl_setopt($crl_cl, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($crl_cl, CURLOPT_FOLLOWLOCATION, true);
    $curlresponse = curl_exec($crl_cl);
    $status_code = curl_getinfo($crl_cl, CURLINFO_HTTP_CODE);
   // echo $status_code . "----call<br/>";
    curl_close($crl_cl);
   // print_r($curlresponse);  
}

function readCall($response_array, $user, $domain) {
    $api_url = "https://".$response_array["server_api_url"].'/ns-api/';
    $crl_cl_red = curl_init();
    if (!$crl_cl_red) {
        die("Couldn't initialize a cURL handle");
    }
    curl_setopt($crl_cl_red, CURLOPT_URL, $api_url);
    curl_setopt($crl_cl_red, CURLOPT_HTTPHEADER, array('Authorization: Bearer ' . $response_array["access_token"]));
    curl_setopt($crl_cl_red, CURLOPT_POST, 1);
    curl_setopt($crl_cl_red, CURLOPT_POSTFIELDS, "object=call&action=read&domain=" . $domain . "&user=" . $user);
    curl_setopt($crl_cl_red, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($crl_cl_red, CURLOPT_FOLLOWLOCATION, true);
    $curlresponse = curl_exec($crl_cl_red);
    $status_code = curl_getinfo($crl_cl_red, CURLINFO_HTTP_CODE);
   // echo $status_code . "----read<br/>";
    curl_close($crl_cl_red);
   // print_r($curlresponse);

    if ($status_code == 200) {
        $xml = new SimpleXMLElement($curlresponse);
        //echo $xml->subscriber->domain;    
        $call_response = array();
        $call_response['orig_callid'] = $xml->call->orig_callid;
        $call_response['orig_match'] = $xml->call->orig_match;
        $call_response['orig_uri'] = $xml->call->orig_uri;
        $call_response['orig_name'] = $xml->call->orig_name;
        $call_response['ani'] = $xml->call->ani;
        $call_response['dnis'] = $xml->call->dnis;
        $call_response['by_action'] = $xml->call->by_action;
        $call_response['by_user'] = $xml->call->by_user;
        $call_response['by_domain'] = $xml->call->by_domain;
        $call_response['term_callid'] = $xml->call->term_callid;
        $call_response['term_user'] = $xml->call->term_user;
        $call_response['term_domain'] = $xml->call->term_domain;
        $call_response['term_uri'] = $xml->call->term_uri;
        $call_response['time_begin'] = $xml->call->time_begin;
        $call_response['time_answer'] = $xml->call->time_answer;
        $call_response['orig_call_info'] = $xml->call->orig_call_info;
        $call_response['term_call_info'] = $xml->call->term_call_info;
        return $call_response;
    } else {
        return 0;
    }
}

function xml2arrayAction( $xmlObject, $out = array () ){
  foreach ( (array) $xmlObject as $index => $node )
   $out[$index] = ( is_object ( $node ) ) ? xml2arrayAction ( $node ) : $node;

      return $out;
 }

$call_status = '';

if (isset($_REQUEST['phn']) && $_REQUEST['phn'] != '') {
 
   if($_REQUEST['readflg'] == 0)
   {
		$response_array = getOauthToken();
		$domain_array = getDomainDetails($response_array);
	 
		$domain = trim($domain_array['domain']);
	  
		$destination = trim($_REQUEST['phn']);
		$user = trim($domain_array['user']);
		$device = trim("sip:" . $user . "@" . $domain);


		sipCreation($response_array, $user, $domain, $device);
		clickToCall($response_array, $user, $domain, $destination);

		$_SESSION['tkn'] = $response_array;
		$_SESSION['usr'] = $user;
		$_SESSION['dmn'] = $domain;
    }
	

    $read_response = readCall($_SESSION['tkn'],$_SESSION['usr'],$_SESSION['dmn']);
   
    $st =array();

    if ($read_response == 0) {
       echo $call_status = 'Please try again';
    } else {
        if($read_response['orig_call_info'] !=''){
          $call_status = $read_response['orig_call_info']; 

 		$st = xml2arrayAction($call_status);
		//echo $st[0];
		if($st[0] == 'active'){ 
			echo $status = "1";
                }else{
                echo trim($st[0]);
                }
        }else{
         echo $call_status = "";  
        }
        
    }
}
?>
