<?php session_start(); 
/*
Plugin Name: ReachUC Click To Call Widget
Plugin URI: https://www.reachuc.com/
Description: ReachUC C2C Widget for Wordpress 
Version: 0.2
Author: ReachUC
License: GPLv2 
Copyright 2018  ReachUC
*/
 
 
class ReachUC_Widget extends WP_Widget {
 
    public function __construct() {
     
        parent::__construct(
            'dwa_widget',
            __( 'ReachUC Widget', 'ReachUCWPC2C' ),
            array(
                'classname'   => 'dwa_widget',
                'description' => __( 'ReachUC Click-to-Call Widget.', 'ReachUCWPC2C' )
                )
        );
              
    }
 
    /** 
     * Front-end display of widget.
     *
     * @see WP_Widget::widget()
     *
     * @param array $args     Widget arguments.
     * @param array $instance Saved values from database.
     */

	public function getOauthToken($username,$password) {
	    
		$api_url = 'https://endpoint.dashmanager.com/ns-controller/';
	    $ch = curl_init();
	    if (!$ch) {
		die("Couldn't initialize a cURL handle");
	    }
	    curl_setopt($ch, CURLOPT_URL, $api_url."?action=auth&username=".$username."&password=".$password);
	    curl_setopt($ch, CURLOPT_POST, 1);
	    curl_setopt($ch, CURLOPT_POSTFIELDS, "");
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	    $status_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);

	    $curlresponse = curl_exec($ch);
	    $response_array = json_decode($curlresponse, true);

	    curl_close($ch);
		$response = array(
			"access_token" => $response_array['access_token'],
			"server_api_url" => $response_array['server_api_url']
		);
	    return $response;
		
	}


	

		

		



    public function widget( $args, $instance ) {   
         
        extract( $args );
         
        $title      = apply_filters( 'widget_title', $instance['title'] );
	$oAuthClientID    = $instance['oAuthClientID'];
	$oAuthSecret    = $instance['oAuthSecret'];
	$apiTargetURI    = $instance['apiTargetURI'];
	//$oAuthTokenURI    = $instance['oAuthTokenURI'];
	$username    = $instance['username'];
	$password    = $instance['password'];
	$css_box    = $instance['css_box'];
	$html_box    = $instance['html_box'];

	$_SESSION['oAuthClientID'] = $oAuthClientID;
	$_SESSION['oAuthSecret'] = $oAuthSecret;
	$_SESSION['apiTargetURI'] = $apiTargetURI;
	//$_SESSION['oAuthTokenURI'] = $oAuthTokenURI;
	$_SESSION['username'] = $username;
	$_SESSION['password'] = $password;

	 ?>
<script src="https://code.jquery.com/jquery-1.11.3.min.js"></script>
  <script type="text/javascript">
		var readflag = 0;
                var statusflag = 0;
            function validation() {  
                var phone_value = document.getElementById("destination").value;
                var regex_phone = new RegExp(/^\+?[0-9(),.-]+$/);
                if (!phone_value.match(regex_phone)) {                    
                    alert("Please enter a Valid Phone No");
                    document.getElementById("destination").focus();
                    return false;
                } else {
					if(statusflag == 0){
						$.ajax({
							url  : '<?php echo plugins_url( "reachucwpc2c/click_to_call.php", dirname(__FILE__) );?>?phn='+phone_value+'&readflg=0',
							type : 'POST',
							dataType: "text",
							beforeSend: function(msg){
							$('#getstatus').text('Please Wait.....');
							},
							success : function(output) {
								readflag =1;
								
								readcallajax();
								
								$('#getstatus').text(output);
								 
							}
						});

					}
                }
            }

 function readcallajax() { 

	if(readflag == 1 && statusflag == 0){

	var phno = document.getElementById("destination").value;

                   $.ajax({
			url  : '<?php echo plugins_url( "reachucwpc2c/click_to_call.php", dirname(__FILE__) );?>?phn='+phno+'&readflg=1',
			type : 'POST',
			dataType: "text",
			success : function(output) {
                       	var outval = parseInt(output);
 			
                       if(outval == "1"){ 
			$('#getstatus').text('Active');
			$('#getstatus').delay(3000).fadeOut('slow');
			}else{

			readcallajax();
			$('#getstatus').text(output);
			}

				  // alert(output)
			
			}
		 });

		}
}

	/*setInterval(function () {
	    readcallajax();
	}, 5000);*/

        </script>   
<style type="text/css">
<?php echo stripslashes($css_box);?>
</style>   
     <div class="widget-wrap">
     <?php echo stripslashes($html_box);?>
        </div>
<?php
         
    }
 
  
    /**
      * Sanitize widget form values as they are saved.
      *
      * @see WP_Widget::update()
      *
      * @param array $new_instance Values just sent to be saved.
      * @param array $old_instance Previously saved values from database.
      *
      * @return array Updated safe values to be saved.
      */
    public function update( $new_instance, $old_instance ) {       
        global $wpdb;
		$instance = $old_instance;
        $auth_response = $this->getOauthToken($new_instance['username'],$new_instance['password']);
        $instance['title'] = strip_tags( $new_instance['title'] );
        //$instance['oAuthClientID'] = strip_tags( $new_instance['oAuthClientID'] );
		//$instance['oAuthSecret'] = strip_tags( $new_instance['oAuthSecret'] );
		//$instance['apiTargetURI'] = strip_tags( $new_instance['apiTargetURI'] );
		//$instance['oAuthTokenURI'] = strip_tags( $new_instance['oAuthTokenURI'] );
		$instance['username'] = strip_tags( $new_instance['username'] );
		$instance['password'] = strip_tags( $new_instance['password'] );
		$instance['css_box'] = strip_tags( $new_instance['css_box'] );
		$instance['html_box'] = $wpdb->escape($new_instance['html_box']);
		$instance['verify_msg'] = strip_tags($auth_response["access_token"]);
		$instance['apiTargetURI'] = strip_tags($auth_response["server_api_url"]);

        return $instance;
         
    }
  
    /**
      * Back-end widget form.
      *
      * @see WP_Widget::form()
      *
      * @param array $instance Previously saved values from database.
      */
    public function form( $instance ) {   
     
	$title      = esc_attr( $instance['title'] );
	//$oAuthTokenURI    = esc_attr( $instance['oAuthTokenURI'] );
	$username    = esc_attr( $instance['username'] );
	$password    = esc_attr( $instance['password'] );
	$css_box    = esc_attr( $instance['css_box'] );
	$html_box    = $instance['html_box'];
	$msg    = esc_attr( $instance['verify_msg'] );

	if($html_box ==""){
		$val_box = '<h3 class="title">We\'ll call you!</h3><input type="text" class="dest-txt" placeholder="Enter Phone Number" name="destination" id="destination"><input type="button" onclick="return validation();" value="CALL" name="submit"  class="call-btn"><div id="getstatus" class="msg"></div>';
		}else{
		$val_box = $html_box;
		}
	if($css_box == ""){
	$css_val = '.call-btn{
	background-color: #444349;
	color:#ffffff;
	border:none;             
	line-height: 35px;
	padding: 0 15px;      margin-top:10px;          
	}            
	.call-btn:hover{
	background-color: #008ACA;             
	color:#ffffff;
	cursor: pointer;
	}
	.dest-txt{
	background: #ffffff none repeat scroll 0 0;
	border: 1px solid #e4e4e4;
	border-radius: 0;
	box-shadow: 0 0 3px rgba(0, 0, 0, 0.08) inset;
	font-size: 13px;
	padding: 10px;
	transition: all 0.2s ease 0s;  
	font-size: 14px;
	}
	.title { margin-bottom:10px; padding-left: 49px; text-align: left;}
	.msg{color: darkseagreen; font-weight: bold; margin-top: 10px; padding-left: 51px;text-align: left; text-transform: capitalize;}';
	}else{
	$css_val = $css_box;
	}
if(!empty($msg) && $msg !=""){
echo '<font color="green"><b>API Connected Successfully</b></font>';
}else{
echo '<font color="red"><b>API Connection Failed</b></font>';
}
        ?>

	<p>
		<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?></label>
		<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
	</p>
	<p>
		<label for="<?php echo $this->get_field_id('username'); ?>"><?php _e('Username:'); ?></label>
		<input class="widefat" id="<?php echo $this->get_field_id('username'); ?>" name="<?php echo $this->get_field_name('username'); ?>" type="text" value="<?php echo $username; ?>" />
	</p>
	<p>
		<label for="<?php echo $this->get_field_id('password'); ?>"><?php _e('Password:'); ?></label>
		<input class="widefat" id="<?php echo $this->get_field_id('password'); ?>" name="<?php echo $this->get_field_name('password'); ?>" type="text" value="<?php echo $password; ?>" />
	</p>
	<p>
		<label for="<?php echo $this->get_field_id('style_box'); ?>"><?php _e('CSS Style Box:'); ?></label>
		<textarea  class="widefat" id="<?php echo $this->get_field_id('css_box'); ?>" name="<?php echo $this->get_field_name('css_box'); ?>" type="textarea" style="height: 200px;"><?php echo $css_val; ?></textarea>
	</p>
	<p>
		<label for="<?php echo $this->get_field_id('html_box'); ?>"><?php _e('HTML Form Box:'); ?></label>
		<textarea class="widefat" id="<?php echo $this->get_field_id('html_box'); ?>" name="<?php echo $this->get_field_name('html_box'); ?>" type="textarea" style="height:200px;"><?php echo stripslashes($val_box); ?></textarea>
	</p>
	
    <?php
    }
     
}
 
/* Register the widget */
add_action( 'widgets_init', function(){
     register_widget( 'ReachUC_Widget' );
});

?>
